## mgen 5.1.1+dfsg

=== debian/changelog ===
mgen (5.1.1+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix Homepage
  * Fix watch file and use version 5

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #928831)
    + Let dh_auto_build pass cross tools to make.
    + Pass C++ compiler as CC.

  [ Jochem Kossen ]
  * Maintain package in Salvage team
    Closes: #1117034
  * Update to 5.1.1
  * Modernize packaging standards (Closes: #884168)

 -- Jochem Kossen <jochem@jkossen.nl>  Mon, 29 Sep 2025 13:23:25 +0200

mgen (5.02.b+dfsg1-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * mgen-doc: Drop unneeded Recommends:
    dwww | dhelp | rarian-compat | doc-central
    (Closes: #913372)

 -- Jeremy Bicha <jbicha@debian.org>  Fri, 09 Nov 2018 22:53:51 -0500

mgen (5.02.b+dfsg1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with GCC 7. (Closes: #853547)

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 27 Oct 2018 18:19:57 +0200

mgen (5.02.b+dfsg1-2) unstable; urgency=medium

  * disabled building of mgen python module in debian/rules to
    avoid build dependency with python. If anybody needs the module
    please file a wishlist bug.

 -- Raoul Gunnar Borenius <borenius@dfn.de>  Wed, 09 Mar 2016 13:51:03 +0100

mgen (5.02.b+dfsg1-1) unstable; urgency=medium

  * new upstream version
    - fixes mgen crashes (Closes: #716226)
    - builds with GCC 6 (Closes: #811638)
  * removed patches that were included by upstream
  * simplified build target 'get-orig-source'
  * fixed bug in watch file

 -- Raoul Gunnar Borenius <borenius@dfn.de>  Wed, 24 Feb 2016 16:19:31 +0100

mgen (5.02+dfsg2-3) unstable; urgency=low

  * enable hardening flags in protolib/ (thanks to Simon Ruderich)
    (Closes: #665313)
  * changed "Recommends: mgen-doc" into "Suggests: mgen-doc" to
    avoid installing the doc-package by default (and thereby installing
    the complete web based debian help system)
  * put doc files in mgen-doc package in it's own directory in /usr/share/doc
    to get rid of lintian warning 'doc-package-depends-on-main-package'
  * bumped Standards-Version to 3.9.3

 -- Raoul Gunnar Borenius <borenius@dfn.de>  Tue, 27 Mar 2012 22:53:25 +0200

mgen (5.02+dfsg2-2) unstable; urgency=low

  * Add patch fixing FTBFS on Ubuntu (thanks to Daniel T Chen)
    (Closes: #657820)
  * Add patch to fix dh_shlibdeps warning (thanks to Nicholas Bamber)
  * enable hardening flags (http://wiki.debian.org/ReleaseGoals)
  * Add patch to get rid of pointer-cast-size-mismatch warning
  * Add patch for kfreebsd port (thanks to Nicholas Bamber)

 -- Raoul Gunnar Borenius <borenius@dfn.de>  Tue, 07 Feb 2012 12:39:11 +0100

mgen (5.02+dfsg2-1) unstable; urgency=low

  * removed unused waf script (Closes: #654490)
  * added get-orig-source target to debian/rules

 -- Raoul Gunnar Borenius <borenius@dfn.de>  Sun, 08 Jan 2012 01:59:22 +0100

mgen (5.02+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #630498)

 -- Raoul Gunnar Borenius <borenius@dfn.de>  Mon, 26 Sep 2011 16:12:53 +0200

=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/USNavalResearchLaboratory/@PACKAGE@/releases?per_page=100
Matching-Pattern: https://github.com/[^"]*/src-@PACKAGE@@ANY_VERSION@-protolib@ARCHIVE_EXT@
DVersion-Mangle: auto
Repacksuffix: +dfsg
Searchmode: plain

## mgen 5.02+dfsg

=== mgen/protolib/wscript ===
#!/usr/bin/env python

# wscript - Build script for waf
# See http://waf.googlecode.com/ for more info

# Environment variables that can be set:
# CFLAGS - Selects compilation options for when the C compiler is used, e.g. '-Wall'. 
# CXXFLAGS - Selects compilation options for when the C++ compiler is used, e.g. '-Wall'. 
# CPPFLAGS - Selects C preprocessor options, e.g. '-DFOO=bar' 
# LINKFLAGS - Extra linker options, e.g. '-L/usr/local -lsome-library' 
# CC - The C compiler that will be used instead of the platform default. Example CC=/usr/bin/gcc-2.95 
# CXX - The C++ compiler that will be used instead of the platform default. Example CXX=/usr/bin/g++-2.95

import os
from optparse import OptionGroup
from platform import system
from subprocess import Popen, PIPE

import Options # Waf module for command line options
from Configure import conf # Waf module for adding configure tools

# the following two variables are used by the target 'waf dist'
VERSION = '2.1'
APPNAME = 'Protokit'

# Constant source directories
INCLUDE = 'include'
COMMON = 'src/common'
UNIX = 'src/unix'
LINUX = 'src/linux'
BSD = 'src/bsd'
WIN32 = 'src/win32'
MANET = 'src/manet'
PYTHON = 'src/python'
JAVA = 'src/java'
WX = 'src/wx'
EXAMPLES = 'examples'

# these variables are mandatory ('/' are converted automatically)
# Base directory for files
srcdir = '.'
# Where to put all compiled files
blddir = 'build'

def set_options(opt):
    '''Sets command line options'''
    # Include command line flags for g++
    opt.tool_options('compiler_cxx')

    # Options for Python for bindings
    opt.tool_options('python')

    misc = OptionGroup(opt.parser, 'Build Options',
            'Options affecting the build process (Call during configure)')
    opt.add_option_group(misc)

    misc.add_option('--debug', action='store_true', help='Build a debug build')
    misc.add_option('--static', action='store_true',
            help='Build a static library (default shared)')

    features = OptionGroup(opt.parser, 'Features',
            'Options that allow you to disable features from the library.  ' +
            'Specify at configure time.')
    opt.add_option_group(features)

    features.add_option('--disable-route', action='store_true', default=False,
            help='Disable the routing classes (ProtoRouteMgr, ProtoRouteTable)')
    features.add_option('--disable-manet', action='store_true', default=False,
            help='Disable the manet classes (ManetMsg, ManetGraph)')
    features.add_option('--disable-wx', action='store_true', default=False,
            help='Disable the wxWidgets application class.')
    features.add_option('--disable-cap', action='store_true', default=False,
            help='Disable the packet capture class (ProtoCap)')
    features.add_option('--disable-detour', action='store_true', default=False,
            help='Disable ProtoDetour')
    features.add_option('--disable-vif', action='store_true', default=False,
            help='Disable ProtoVif')

    bindings = OptionGroup(opt.parser, 'Language Bindings/Other Libraries',
            'Options to build other libraries for Protolib.  Specify at configure time.')
    opt.add_option_group(bindings)

    bindings.add_option('--build-python', action='store_true', default=False,
            help='Build ProtoPipe Python wrapper.')
    bindings.add_option('--build-java', action='store_true', default=False,
            help='Build Java wrapper.')
    bindings.add_option('--build-ns3', action='store_true', default=False,
            help='Build NS3 Library.  Reads NS3_HOME environment variable for location of NS3.')

    examples = OptionGroup(opt.parser, 'Examples',
            'Options to pick which example programs to build.  Specify these at build time.')
    opt.add_option_group(examples)

    examples.add_option('--ex-all', action='store_true', default=False,
            help='Builds all examples')
    examples.add_option('--ex-protoExample', action='store_true', default=False)
    examples.add_option('--ex-vifExample', action='store_true', default=False)
    examples.add_option('--ex-timerTest', action='store_true', default=False)
    examples.add_option('--ex-threadExample', action='store_true', default=False)
    examples.add_option('--ex-pipeExample', action='store_true', default=False)
    examples.add_option('--ex-protoCapExample', action='store_true', default=False)
    examples.add_option('--ex-detourExample', action='store_true', default=False)
    examples.add_option('--ex-graphExample', action='store_true', default=False)
    examples.add_option('--ex-msgExample', action='store_true', default=False)
    examples.add_option('--ex-graphBuilder', action='store_true', default=False)
    examples.add_option('--ex-graphRider', action='store_true', default=False)
    examples.add_option('--ex-simpleTcpExample', action='store_true', default=False)
    examples.add_option('--ex-wxProtoExample', action='store_true', default=False)

def configure(conf):
    '''Performs the configuration checks'''

    if system() in ['Windows','Microsoft']:
        conf.env['MSVC_TARGETS'] = 'x86 amd64'

    # Check for GCC and related tools
    conf.check_tool('compiler_cxx')
	
    ### Set define flags ###
    conf.env.append_unique('CXXDEFINES', '_FILE_OFFSET_BITS=64')

    ## System specific stuff
    if system() in ['Linux', 'Darwin', 'FreeBSD']:
        conf.env.append_unique('CXXDEFINES', 'UNIX')

    if system() == 'Linux':
        conf.env.append_unique('CXXDEFINES', ['LINUX', 'HAVE_SCHED'])
        conf.env.append_unique('system_libs', ['dl', 'rt'])

    if system() == 'Darwin':
        conf.env.append_unique('CXXDEFINES', 'MACOSX')
        #conf.env.append_unique('CXXFLAGS', '-arch i386 -arch x86_64')
        #conf.env.append_unique('LINKFLAGS', '-arch i386 -arch x86_64')
        conf.env.append_unique('system_libs', 'resolv')

    if system() == 'FreeBSD':
        conf.env.append_unique('system_libs', 'pthread')

    if system() in ['Windows','Microsoft']:
        conf.env.append_unique('CXXDEFINES', ['WIN32', '_CRT_SECURE_NO_WARNINGS'])
        conf.env.append_unique('system_libs',
                ['ws2_32', 'iphlpapi', 'user32', 'gdi32'])

    ## Check for different features for define flags

    # What about regular NETSEC
    # if conf.check(header_name='net/security.h' define_name='HAVE_NETSEC'):
    #   conf.env.append_unique('CXXDEFINES', ['NETSEC', 'HAVE_NETSEC']

    # Note: moved this to Linux-only for now - RBA
    #if conf.check(header_name='sched.h'):
    #    conf.env.append_unique('CXXDEFINES', 'HAVE_SCHED')

    if conf.check(header_name='assert.h'):
        conf.env.append_unique('CXXDEFINES', 'HAVE_ASSERT')

    if conf.check(function_name='pselect', header_name='sys/select.h'):
        conf.env.append_unique('CXXDEFINES', 'HAVE_PSELECT')

    if not conf.check(msg='Checking for SCM_RIGHTS', fragment='''
        #include <sys/socket.h>
        #include <sys/un.h>
        int main() {
            int i = SCM_RIGHTS;
            struct sockaddr_un j;
            j.sun_len = 10;
            return 0;
        }'''):
        conf.env.append_unique('CXXDEFINES', 'NO_SCM_RIGHTS')

    # The stuff with the include is becaue sockaddr_in6 is in a different place
    # on windows
    if conf.check(msg='Checking for IPv6', fragment='''
        #include <%s>
        int main() {
            struct sockaddr_in6 *x;
            return 0;
        }''' % ('netinet/in.h', 'ws2tcpip.h')[system() in ['Windows','Microsoft']]):
        conf.env.append_unique('CXXDEFINES', 'HAVE_IPV6')

    ## Choose our build type
    if Options.options.static:
        conf.env['protolib_type'] = 'cstaticlib'
    else:
        conf.env['protolib_type'] = 'cshlib'

    ## Set define flags for optimized/non-optimized build
    if Options.options.debug:
        conf.env.append_unique('CXXDEFINES', 'PROTO_DEBUG')
        if system() in ['Windows','Microsoft']:
            conf.env.append_unique('CXXFLAGS', ['/Od', '/RTC1', '/D_DEBUG', '/ZI'])
        else:
            conf.env.append_unique('CXXFLAGS', ['-g', '-O0'])
    else:
        conf.env.append_unique('CXXDEFINES', 'PROTO_MSG')
        if system() in ['Windows','Microsoft']:
            conf.env.append_unique('CXXFLAGS', ['/Ox', '/DNDEBUG'])
        else:
            conf.env.append_unique('CXXFLAGS', ['-O3'])

    ## Check for system specific libraries
    for lib in conf.env['system_libs']:
        conf.check(lib=lib, mandatory=True)

    ## Do checks for stuff depending on --disable-* flags
    conf.env['disable_route'] = Options.options.disable_route
    conf.env['disable_manet'] = Options.options.disable_manet
    conf.env['disable_cap'] = Options.options.disable_cap
    conf.env['disable_detour'] = Options.options.disable_detour
    conf.env['disable_vif'] = Options.options.disable_vif

    conf.env['disable_wx'] = Options.options.disable_wx
    if not conf.env['disable_wx']:
        conf.check_wx()

    ## Do checks for language bindings
    conf.env['build_python'] = Options.options.build_python
    if conf.env['build_python']:
        conf.check_tool('python')
        conf.check_python_version((2,4))
        conf.check_python_headers()

    conf.env['build_java'] = Options.options.build_java
    if conf.env['build_java']:
        conf.check_tool('java')
        try:
            if system() in ['Windows','Microsoft']:
                cxxflags = ['/I%s\include' % os.environ['JAVA_HOME']]
                cxxflags.append('/I%s\include\win32' % os.environ['JAVA_HOME'])
            else:
                cxxflags = ['-I%s/include' % os.environ['JAVA_HOME']]
                cxxflags.append('-I%s/include/%s' % (
                    os.environ['JAVA_HOME'],
                    system().lower()))
            conf.check(header_name='jni.h', cxxflag=cxxflags, mandatory=True)
            conf.check(header_name='jni_md.h', cxxflag=cxxflags, mandatory=True)
            conf.env.append_unique('CXXFLAGS_JAVA', cxxflags)
        except KeyError:
            conf.fatal('JAVA_HOME environment variable not set.')

    conf.env['build_ns3'] = Options.options.build_ns3
    if conf.env['build_ns3']:
        try:
            conf.check(header_name='ns3/core-module.h',
                    cxxflag='-I%s/build/debug' % os.environ['NS3_HOME'],
                    mandatory=True)
            conf.env['NS3_HOME'] = os.environ['NS3_HOME']
            conf.env.append_unique('CXXDEFINES_NS3', ['SIMULATE', 'NS3'])
        except KeyError:
            conf.fatal('NS3_HOME environment variable not set.')
            
    conf.env['protolib_install'] = True

def build(bld):
    '''Performs the compilation'''
    protokit = bld.new_task_gen(
            # cxx builds c++ and cstaticlib or cshlib builds libraries
            features = 'cxx %s' % bld.env['protolib_type'],
            # waf will turn this into libprotokit.so
            target = 'protokit',
            # for shared libraries, include the .so version number
            vnum = VERSION,
            # where the header files are
            includes = [INCLUDE],
            # for uselib_local
            export_incdirs = [INCLUDE],
            # list of libraries to link against
            uselib = [x.upper() for x in bld.env['system_libs']],
            # Add common source files
            source = ['%s/%s.cpp' % (COMMON, x) for x in [
                'protoAddress', 'protoApp', 'protoBitmask', 'protoChannel',
                'protoDispatcher', 'protoPipe', 'protoPkt', 'protoPktARP',
                'protoPktETH', 'protoPktIP', 'protoPktRTP', 'protoSocket',
                'protoTime', 'protoTimer', 'protoTree', 'protoList',
                'protoGraph', 'protoSpace', 'protoDebug']]
    )
    
    if bld.env['protolib_install'] != True:
        protokit.install_path = None
        
    # Process system specific source files
    system_source = []
    if system() in ['Linux', 'Darwin', 'FreeBSD']:
        system_source.append(UNIX + '/unixVif.cpp')

    if system() == 'Linux':

=== debian/control ===
Source: mgen
Section: net
Priority: optional
Maintainer: Raoul Gunnar Borenius <borenius@dfn.de>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 3.9.2
Homepage: http://cs.itd.nrl.navy.mil/work/mgen/

Package: mgen
Architecture: any
Recommends: mgen-doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: packet generator for IP network performance tests
 MGEN provides the ability to perform IP network performance tests
 and measurements using TCP and UDP/IP traffic. Test messages
 can be generated, received and logged. MGEN offers control over
 all network parameters and timing of these messages. All this can be
 done either via the command line or defined in a file format for
 greater reproducibility.

Package: mgen-doc
Architecture: all
Section: doc
Recommends: dwww | dhelp | rarian-compat | doc-central
Depends: ${misc:Depends}
Description: mgen user and reference guide
 This package contains the HTML documentation for MGEN, a packet generator
 for IP network performance tests. It can also be found online at
 http://cs.itd.nrl.navy.mil/work/mgen/ .

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

override_dh_auto_build:
	cd mgen/makefiles && make -f Makefile.linux

override_dh_auto_clean:
	cd mgen/makefiles && make -f Makefile.linux clean

override_dh_installdocs:
	dh_installdocs --link-doc=mgen

override_dh_installchangelogs:
	dh_installchangelogs mgen/VERSION.TXT

%:
	dh $@

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$// \
    http://downloads.pf.itd.nrl.navy.mil/mgen/src-mgen-([\d.]+)\.tar\.gz \
    debian sh debian/repack.stub

## mgen 5.02+dfsg2

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Raoul Gunnar Borenius <borenius@dfn.de>
 Build-Depends: debhelper (>= 8.0.0)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://cs.itd.nrl.navy.mil/work/mgen/
 
 Package: mgen
 Architecture: any
-Recommends: mgen-doc
+Suggests: mgen-doc
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: packet generator for IP network performance tests
  MGEN provides the ability to perform IP network performance tests

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
# This has to be exported to make some magic below work.
export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifeq ($(shell uname -s),GNU/kFreeBSD)
    MAKEFILE:=Makefile.freebsd
else
    MAKEFILE:=Makefile.linux
endif

override_dh_auto_build:
	cd mgen/makefiles && make -f $(MAKEFILE)

override_dh_auto_clean:
	cd mgen/makefiles && make -f $(MAKEFILE) clean

override_dh_installchangelogs:
	dh_installchangelogs mgen/VERSION.TXT

%:
	dh $@ 

get-orig-source:
	uscan  --force-download --repack --verbose

## mgen 5.02.b%2Bdfsg1

=== debian/watch ===
version=3
opts=uversionmangle=s/([a-z])/\.$1/g,dversionmangle=s/\+dfsg\d*$// \
    http://downloads.pf.itd.nrl.navy.mil/mgen/src-mgen-(.+)\.tar\.gz \
    debian debian/repack.sh

## mgen 5.02.b+dfsg1

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: net
 Priority: optional
 Maintainer: Raoul Gunnar Borenius <borenius@dfn.de>
-Build-Depends: debhelper (>= 8.0.0)
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9)
+Standards-Version: 3.9.7
 Homepage: http://cs.itd.nrl.navy.mil/work/mgen/
 
 Package: mgen
@@ -21,7 +21,6 @@
 Package: mgen-doc
 Architecture: all
 Section: doc
-Recommends: dwww | dhelp | rarian-compat | doc-central
 Depends: ${misc:Depends}
 Description: mgen user and reference guide
  This package contains the HTML documentation for MGEN, a packet generator

=== debian/rules ===
#!/usr/bin/make -f

export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifeq ($(shell uname -s),GNU/kFreeBSD)
    MAKEFILE:=Makefile.freebsd
else
    MAKEFILE:=Makefile.linux
endif

override_dh_auto_build:
	cd makefiles && make -f $(MAKEFILE)

override_dh_auto_clean:
	cd makefiles && make -f $(MAKEFILE) clean
	rm -rf build

# do not build the python module
override_dh_auto_install:

override_dh_installchangelogs:
	dh_installchangelogs VERSION.TXT

%:
	dh $@ 

get-orig-source:
	uscan --no-conf --verbose --download-current-version --destdir ../

## mgen 5.02.c%2Breally5.1.1%2Bdfsg

=== protolib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
cmake_policy(SET CMP0077 NEW)

# set the project name
project(protokit)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(COMMON src/common)

option(PROTOKIT_BUILD_EXAMPLES "Enables building of the examples in /examples." OFF)
option(PROTOKIT_BUILD_PYTHON "Enables building of python bindings **NOT IMPLEMENTED**." OFF)
option(PROTOKIT_BUILD_JAVA "Enables building of jave bindings **NOT IMPLEMENTED**." OFF)
option(PROTOKIT_ENABLE_DEBUG "Include debugging messages/logging **NOT IMPLEMENTED**." OFF)
option(PROTOKIT_ENABLE_WX "Enables building with WX Widgets" OFF)
option(PROTOKIT_ENABLE_INSTALL "Enables install target" OFF)

# Availability checks
include(CheckCXXSymbolExists)
include(CheckStructHasMember)
include(CheckTypeSize)
include(CheckIncludeFiles)
include(CheckLibraryExists)

check_include_files( sys/timerfd.h HAVE_TIMERFD_H)
if(HAVE_TIMERFD_H)
	list(APPEND PLATFORM_DEFINITIONS USE_TIMERFD)
endif()

check_include_files( sys/select.h HAVE_SELECT_H)
check_include_files( sys/epoll.h HAVE_EPOLL_H)
if(HAVE_EPOLL_H)
	list(APPEND PLATFORM_DEFINITIONS USE_EPOLL)
	message(STATUS "Using epoll")
elseif(HAVE_SELECT_H)
	list(APPEND PLATFORM_DEFINITIONS USE_SELECT)
	message(STATUS "Using select")
else()
	message(STATUS "Using neither epoll or select")
endif()

check_cxx_symbol_exists( sched_setscheduler "sched.h" HAVE_SCHED_SETSCHEDULER )
if(HAVE_SCHED_SETSCHEDULER)
	list(APPEND PLATFORM_DEFINITIONS HAVE_SCHED)
endif()

check_cxx_symbol_exists(assert "assert.h" HAVE_ASSERT)
if(HAVE_ASSERT)
	list(APPEND PLATFORM_DEFINITIONS HAVE_ASSERT)
endif()

check_cxx_symbol_exists(lockf "unistd.h" HAVE_LOCKF)
if(HAVE_LOCKF)
	list(APPEND PLATFORM_DEFINITIONS HAVE_LOCKF)
endif()

check_cxx_symbol_exists(flock "sys/file.h" HAVE_FLOCK)
if(HAVE_FLOCK)
	list(APPEND PLATFORM_DEFINITIONS HAVE_FLOCK)
endif()

check_cxx_symbol_exists(eventfd "sys/eventfd.h" HAVE_EVENTFD) #USE
if(HAVE_EVENTFD)
	list(APPEND PLATFORM_DEFINITIONS USE_EVENTFD)
endif()

check_cxx_symbol_exists(pselect "sys/select.h" HAVE_PSELECT)
if(HAVE_PSELECT)
	list(APPEND PLATFORM_DEFINITIONS HAVE_PSELECT)
endif()

check_struct_has_member(sockaddr_un sun_len "sys/un.h" HAVE_SUN_LEN)
if(NOT HAVE_SUN_LEN)
	list(APPEND PLATFORM_DEFINITIONS NO_SCM_RIGHTS)
endif()

check_cxx_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)
if(HAVE_IPV6)
    list(APPEND PLATFORM_DEFINITIONS HAVE_IPV6)
endif()

# Check for libraries
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
find_package(PkgConfig)
if(PkgConfig_FOUND)
	pkg_check_modules(LibXml2 "libxml-2.0")
	if(CMAKE_HOST_SYSTEM_NAME MATCHES "GNU")
		pkg_check_modules(LIBPCAP "libpcap")
	endif()
else()
	find_package(LibXml2)
endif()
if(LibXml2_FOUND)
	include_directories(${LIBXML2_INCLUDE_DIR} ${LibXml2_INCLUDE_DIRS})
	list(APPEND PLATFORM_LIBS ${LIBXML2_LIBRARIES} ${LibXml2_LIBRARIES})
	list(APPEND PUBLIC_HEADER_FILES include/protoXml.h)
	list(APPEND COMMON_SOURCE_FILES ${COMMON}/protoXml.cpp)
	set(PROTOLIB_REQUIRES_PRIVATE "${PROTOLIB_REQUIRES_PRIVATE} libxml-2.0")
endif()

if(LIBPCAP_FOUND)
	include_directories(${LIBPCAP_INCLUDE_DIRS})
	list(APPEND PLATFORM_LIBS ${LIBPCAP_LIBRARIES})
	list(APPEND PLATFORM_SOURCE_FILES ${COMMON}/pcapCap.cpp)
	set(PROTOLIB_REQUIRES_PRIVATE "${PROTOLIB_REQUIRES_PRIVATE} libpcap")
endif()

# Note: cannot append, need to use PARENT_SCOPE
set(REQUIRES_PRIVATE "${REQUIRES_PRIVATE} ${PROTOLIB_REQUIRES_PRIVATE}" PARENT_SCOPE)

if(PROTOKIT_ENABLE_WX)
        find_package(wxWidgets REQUIRED COMPONENTS core base)
	if(wxWidgets_FOUND)
		include(${wxWidgets_USE_FILE})
		list(APPEND PLATFORM_LIBS ${wxWidgets_LIBRARIES})
		list(APPEND PLATFORM_SOURCE_FILES src/wx/wxProtoApp.cpp)
	endif()
endif()

# List header files
list(APPEND PUBLIC_HEADER_FILES
include/manetGraph.h        
include/manetGraphML.h      
include/manetMsg.h          
include/ns3ProtoSimAgent.h  
include/protoAddress.h      
include/protoApp.h          
include/protoAverage.h      
include/protoBase64.h       
include/protoBitmask.h      
include/protoCap.h          
include/protoChannel.h     
include/protoCheck.h     
include/protoDebug.h       
include/protoDefs.h        
include/protoDetour.h      
include/protoDispatcher.h  
include/protoEvent.h       
include/protoFile.h        
include/protoGraph.h       
include/protoJson.h        
include/protoLFSR.h        
include/protoList.h     
include/protoNet.h      
include/protoNotify.h   
include/protoPipe.h     
include/protoPkt.h      
include/protoPktARP.h   
include/protoPktETH.h   
include/protoPktIGMP.h  
include/protoPktIP.h    
include/protoPktRIP.h   
include/protoPktRTP.h   
include/protoPktTCP.h      
include/protoQueue.h       
include/protoRouteMgr.h    
include/protoRouteTable.h  
include/protoSerial.h      
include/protoSimAgent.h    
include/protoSocket.h      
include/protoSpace.h       
include/protoString.h
include/protoTime.h
include/protoTimer.h
include/protoTree.h
include/protoVersion
include/protoVif.h
include/protokit.h
include/testFuncs.h
include/wxProtoApp.h
include/unix/zebraRouteMgr.h
)

# List platform-independent source files
list(APPEND COMMON_SOURCE_FILES 
          ${COMMON}/protoAddress.cpp  
		  ${COMMON}/protoApp.cpp 
		  ${COMMON}/protoBase64.cpp 
          ${COMMON}/protoBitmask.cpp 
		  ${COMMON}/protoCap.cpp 
		  ${COMMON}/protoChannel.cpp 
		  ${COMMON}/protoDebug.cpp 
		  ${COMMON}/protoDispatcher.cpp 
		  ${COMMON}/protoEvent.cpp 
          ${COMMON}/protoFile.cpp 
		  ${COMMON}/protoGraph.cpp 
		  ${COMMON}/protoJson.cpp 
		  ${COMMON}/protoLFSR.cpp 
		  ${COMMON}/protoList.cpp 
          ${COMMON}/protoNet.cpp 
          ${COMMON}/protoPipe.cpp 
          ${COMMON}/protoPkt.cpp 
		  ${COMMON}/protoPktARP.cpp 
		  ${COMMON}/protoPktETH.cpp 
		  ${COMMON}/protoPktIGMP.cpp 
		  ${COMMON}/protoPktIP.cpp 
		  ${COMMON}/protoPktRTP.cpp 
		  ${COMMON}/protoQueue.cpp 
          ${COMMON}/protoRouteMgr.cpp 
		  ${COMMON}/protoRouteTable.cpp 
          ${COMMON}/protoSerial.cpp 
		  ${COMMON}/protoSocket.cpp 
          ${COMMON}/protoSpace.cpp 
		  ${COMMON}/protoString.cpp
          ${COMMON}/protoTime.cpp 
		  ${COMMON}/protoTimer.cpp 
          ${COMMON}/protoTree.cpp 
          ${COMMON}/protoVif.cpp )

# Setup platform independent include directory
list(APPEND INCLUDE_DIRS ${CMAKE_CURRENT_LIST_DIR}/include )

# Setup platform dependent libraries, defines, source file and compiler flags
if(MSVC)
	list(APPEND PLATFORM_LIBS ws2_32 iphlpapi user32 gdi32 Advapi32 ntdll)
	list(APPEND PLATFORM_DEFINITIONS _CRT_SECURE_NO_WARNINGS)
	list(APPEND PLATFORM_SOURCE_FILES src/win32/win32Net.cpp src/win32/win32RouteMgr.cpp)
	list(APPEND PLATFORM_FLAGS /EHsc)
elseif(UNIX)
	list(APPEND PLATFORM_DEFINITIONS UNIX _FILE_OFFSET_BITS=64)
	list(APPEND PLATFORM_LIBS pthread)
	list(APPEND PLATFORM_SOURCE_FILES 	src/unix/unixNet.cpp 
										src/unix/unixSerial.cpp 
										src/unix/unixVif.cpp
										src/manet/manetGraph.cpp
										src/manet/manetMsg.cpp)
	if(${CMAKE_SYSTEM_NAME} STREQUAL Linux)
		list(APPEND PLATFORM_DEFINITIONS LINUX )
		list(APPEND PLATFORM_LIBS dl rt)
		list(APPEND PLATFORM_SOURCE_FILES 	src/linux/linuxCap.cpp 
										    src/linux/linuxNet.cpp 
										    src/linux/linuxRouteMgr.cpp
										    src/unix/zebraRouteMgr.cpp)
		
		check_library_exists(netfilter_queue pktb_alloc "" HAVE_NETFILTER_QUEUE)
		if(HAVE_NETFILTER_QUEUE)
			list(APPEND PLATFORM_LIBS NETFILTER_QUEUE)
			list(APPEND PLATFORM_SOURCE_FILES src/linux/linuxDetour.cpp)
			list(APPEND examples detourExample)
		endif()
	elseif(${CMAKE_SYSTEM_NAME} STREQUAL Darwin )
		list(APPEND PLATFORM_DEFINITIONS MACOSX )
		list(APPEND PLATFORM_SOURCE_FILES 	src/bsd/bsdDetour.cpp
											src/bsd/bsdRouteMgr.cpp
											src/bsd/bsdNet.cpp
											src/unix/bpfCap.cpp)
            SET(CMAKE_C_ARCHIVE_CREATE   "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
            SET(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
            SET(CMAKE_C_ARCHIVE_FINISH   "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
            SET(CMAKE_CXX_ARCHIVE_FINISH "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
	endif()
endif()

include(GNUInstallDirs)

# Setup target

add_library(protokit STATIC ${PLATFORM_SOURCE_FILES} ${COMMON_SOURCE_FILES} ${PUBLIC_HEADER_FILES})
add_library(protokit::protokit ALIAS protokit)
target_link_libraries(protokit PRIVATE ${PLATFORM_LIBS})
target_compile_definitions(protokit PUBLIC ${PLATFORM_DEFINITIONS})
target_compile_options(protokit PUBLIC ${PLATFORM_FLAGS})
target_include_directories(protokit PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories(protokit PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)

# Install target
if(${PROTOKIT_ENABLE_INSTALL})
	install( TARGETS protokit EXPORT protokitTargets
			RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} )

	install( EXPORT protokitTargets
		FILE protokitConfig.cmake
		NAMESPACE protokit::
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/protokit
	)

	install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

	export(EXPORT protokitTargets
		FILE ${CMAKE_CURRENT_BINARY_DIR}/protokitTargets.cmake
		NAMESPACE protokit::)
		
	export(PACKAGE protokit)
endif()

if(PROTOKIT_BUILD_EXAMPLES)
	# Setup examples
	list(APPEND examples 
	base64Example
	# detourExample This depends on netfilterqueue so doesn't work as a "simple example"
	eventExample
	fileTest
	graphExample
	#'graphRider', (this depends on manetGraphML.cpp so doesn't work as a "simple example"
	lfsrExample
	msg2MsgExample
	#'msgExample',  (this depends on examples/testFuncs.cpp so doesn't work as a "simple example"
	netExample
	pipe2SockExample
	pipeExample
	protoCapExample
	protoExample
	protoFileExample
	queueExample
	serialExample
	simpleTcpExample
	sock2PipeExample
	threadExample
	timerTest
	vifExample
	vifLan
	#'wxProtoExample', (this depends on wxWidgets (could use wx-config to test) so doesn't work as a "simple example"
	udptest)

	foreach(example ${examples})
		add_executable(${example} examples/${example}.cpp)
		target_link_libraries(${example} PRIVATE protokit)
		include_directories(${CMAKE_SOURCE_DIR}/include)
	endforeach()
endif()

## mgen 5.02.c+really5.1.1+dfsg

=== debian/changelog ===
mgen (5.02.c+really5.1.1+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix Homepage
  * Fix watch file and use version 5

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #928831)
    + Let dh_auto_build pass cross tools to make.
    + Pass C++ compiler as CC.

  [ Jochem Kossen ]
  * Maintain package in Salvage team
    Closes: #1117034
  * Update to 5.1.1
  * Modernize packaging standards (Closes: #884168)
  * Use +really version to make it appear higher than 5.02.b

 -- Jochem Kossen <jochem@jkossen.nl>  Mon, 03 Nov 2025 20:55:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,19 @@
 Source: mgen
 Section: net
 Priority: optional
-Maintainer: Raoul Gunnar Borenius <borenius@dfn.de>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.7
-Homepage: http://cs.itd.nrl.navy.mil/work/mgen/
+Maintainer: Package Salvaging Team <team+salvage@tracker.debian.org>
+Uploaders: Raoul Gunnar Borenius <borenius@dfn.de>,
+           Jochem Kossen <jochem@jkossen.nl>
+Build-Depends:
+ debhelper-compat (= 13),
+ dh-python,
+ libpcap-dev,
+ python3-all-dev,
+ python3-setuptools
+Standards-Version: 4.7.2
+Vcs-Browser: https://salsa.debian.org/salvage-team/mgen
+Vcs-Git: https://salsa.debian.org/salvage-team/mgen.git
+Homepage: https://www.nrl.navy.mil/Our-Work/Areas-of-Research/Information-Technology/NCS/MGEN/
 
 Package: mgen
 Architecture: any
@@ -25,4 +34,4 @@
 Description: mgen user and reference guide
  This package contains the HTML documentation for MGEN, a packet generator
  for IP network performance tests. It can also be found online at
- http://cs.itd.nrl.navy.mil/work/mgen/ .
+ https://github.com/USNavalResearchLaboratory/mgen/blob/master/doc/mgen.pdf .

=== debian/rules ===
#!/usr/bin/make -f

export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export PYBUILD_NAME=mgen

ifeq ($(shell uname -s),GNU/kFreeBSD)
    MAKEFILE:=Makefile.freebsd
else
    MAKEFILE:=Makefile.linux
endif

override_dh_auto_build:
	dh_auto_build --sourcedirectory=makefiles --buildsystem=makefile -- -f $(MAKEFILE) CC='$$(CXX)'

override_dh_auto_clean:
	cd makefiles && make -f $(MAKEFILE) clean
	rm -rf build

# do not build the python module
override_dh_auto_install:

override_dh_installchangelogs:
	dh_installchangelogs VERSION.TXT

%:
	dh $@ --buildsystem=pybuild

=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/USNavalResearchLaboratory/@PACKAGE@/releases?per_page=100
Matching-Pattern: https://github.com/[^"]*/src-@PACKAGE@@ANY_VERSION@-protolib@ARCHIVE_EXT@
Dversion-Mangle: s/5\.02\.c\+really(\d+\.\d+\.\d+)/$1/;s/@DEB_EXT@//
Uversion-Mangle: s/^/5.02.c+really/
Repacksuffix: +dfsg
Searchmode: plain
